program swiss;
const
   MAXN = 10000;
   MAXM = 1000000;
type
   edge  = record
              first, second, value : longint;
           end;
   dedge = record
              second, value : longint;
           end;
   path  = record
              start          : longint;
              first, second  : longint;
              fvalue, svalue : longint;
           end;
var
   m, n  : longint;
   P     : array [1..MAXN] of path;
   edges : array [1..MAXM] of edge;
   ec    : longint;
   pos   : array [0..MAXN] of longint;
   out   : array [1..MAXM] of dedge;
   deg   : array [1..MAXN] of longint;

procedure SetEdge(v, w, value : longint);
begin {dame hranu na spravne misto do pole out}
   out[pos[v]-deg[v]+1].second := w;
   out[pos[v]-deg[v]+1].value := value;
   dec(deg[v]);
end;

var
   first, second, value : longint;
   i, v, w, x, e, f     : longint;
   fin                  : text;
   fout                 : text;
   best, a, b, c, d     : longint;
   {nase nejlepsi reseni a-b-c-d-a s hodnotou best}
begin
   assign(fin,'swiss.in');
   reset(fin);
   assign(fout,'swiss.out');
   rewrite(fout);

   readln(fin, n, m);

   for i := 1 to n do
      deg[i] := 0;

   for i := 1 to m do
   begin
      readln(fin, edges[i].first, edges[i].second, edges[i].value);
      inc(deg[edges[i].first]);
      inc(deg[edges[i].second]);
   end;

   pos[0] := 0;
   for v := 1 to n do {spocteme, kam umistit hrany vedouci z vrcholu}
      pos[v] := pos[v-1] + deg[v];

   for i := 1 to m do
   begin
      SetEdge(edges[i].first, edges[i].second, edges[i].value);
      SetEdge(edges[i].second, edges[i].first, edges[i].value);
   end;

   best := 0;

   for v := 1 to n do
   begin
      for e := pos[v-1]+1 to pos[v] do
      begin
         w := out[e].second;
         for f := pos[w-1]+1 to pos[w] do
         begin
            x := out[f].second;
            if x = v then continue; {vratili jsme se zpet}

            if v <> P[x].start then {inicializujeme hodnoty}
            begin
               P[x].start := v;
               P[x].fvalue := 0;
               P[x].svalue := 0;
            end;

            if out[e].value + out[f].value > P[x].fvalue then
            begin
               P[x].second := P[x].first;
               P[x].svalue := P[x].fvalue;
               P[x].first := w;
               P[x].fvalue := out[e].value + out[f].value;
            end
            else if out[e].value + out[f].value > P[x].svalue then
            begin
               P[x].second := w;
               P[x].svalue := out[e].value + out[f].value;
            end;

            if (P[x].svalue > 0) and (P[x].fvalue + P[x].svalue > best) then
            begin
               best := P[x].fvalue + P[x].svalue;
               a := v;
               b := P[x].first;
               c := x;
               d := P[x].second;
            end;
         end;
      end;
   end;

   if best = 0 then
      writeln(fout, 'NEEXISTUJE')
   else
   begin
      writeln(fout, best);
      writeln(fout, a, ' ', b, ' ', c, ' ', d, ' ', a);
   end;
   close(fout);
end.
