#include <stdio.h>
#define MAXN 10000
#define MAXM 1000000

struct edge {
  int from, to, value;
};

struct dedge {
  int to, value;
};

int m, n;

struct edge edges[MAXM];
int ec;

int pos[MAXN+1];
struct dedge out[MAXM];

int main() 
{
  FILE * fin = fopen("swiss.in", "r");
  FILE * fout = fopen("swiss.out", "w");
  fscanf(fin, "%i %i", &n, &m);

  int i;
  int deg[MAXN+1] = {0};
  for (i=0; i<m; i++) {
    fscanf(fin, "%i %i %i", &edges[i].from, &edges[i].to, &edges[i].value);
    deg[edges[i].from]++;
    deg[edges[i].to]++;
  }

  int v;
  for (v=1; v<=n; v++) //spocteme si pozice hran jednotlivych vrcholu
    pos[v] = pos[v-1] + deg[v];

  for (i=0; i<m; i++) { //zapiseme hrany do pole ve spravnem poradi
    v = edges[i].from;
    out[pos[v]-deg[v]].to = edges[i].to;
    out[pos[v]-deg[v]].value = edges[i].value;
    deg[v]--;
    v = edges[i].to;
    out[pos[v]-deg[v]].to = edges[i].from;
    out[pos[v]-deg[v]].value = edges[i].value;
    deg[v]--;
  }

  int best = 0, a, b, c, d; // nas nejlepsi okruh a-b-c-d-a

  for (v=1; v<=n; v++) {
    int e, f, g, h;
    for (e=pos[v-1]; e<pos[v]; e++) {
      int w = out[e].to;
      for (f=pos[w-1]; f<pos[w]; f++) {
        int x = out[f].to;
        if (x == v) continue; //vratili jsme se zpet
        for (g=pos[x-1]; g<pos[x]; g++) {
          int y = out[g].to;
          if (y == w) continue;
          for (h=pos[y-1]; h<pos[y]; h++) {
            if (out[h].to != v) continue;
            if (out[e].value + out[f].value + out[g].value + out[h].value > best) {
              best = out[e].value + out[f].value + out[g].value + out[h].value;
              a = v; b = w; c = x; d = y;
            }
          }
        }
      }
    }
  }

  if (!best)
    fprintf(fout, "NEEXISTUJE\n");
  else
    fprintf(fout, "%i\n%i %i %i %i %i\n", best, a, b, c, d, a);

  return 0;
}
